      subroutine aground
     & (ths, thv, thknot, phi, p14, 
     & rsogrou, rdsgrou, rsdgrou, rddgrou)
c
c   Directional-hemispherical reflectance rsdground and albedo 
c   (hemispherical-hemispherical reflectance) rddgrou 
c   of ground vegetation.                          A. Kuusk  5.9.2002
c   Input:
c     & (thknot, phi, p14, ths, thv, 
c   Output:
c   & rsogrou, rdsgrou, rsdgrou, rddgrou)
c
      include 'par.h'
c
      dimension thknot(nknots), p14(nknots)
      common /pidr/ pi, dr
c
c           ! Albedo of ground vegetation is calculated integrating
c           ! ACRM with Gauss quadrature in the perpendicular plain
c           ! phi = 90 deg
c
      phisave  = phi
      thssave = ths
      thvsave = thv
      skyl  = 1.d0
      call smcrm
     &  (penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rdsgrou = sbgr
c
      skyl  = 0.d0
      call smcrm
     &  (penalty, bc1, bs1, bdplants, bdsoil)
      sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
      rsogrou = sbgr
c
      phi   = pi/2.d0
      rsdgrou = 0.d0
      do jthk = 1, nknots
         ths  = thknot(jthk)
         call smcrm
     &  (penalty, bc1, bs1, bdplants, bdsoil)
         sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
         rsdgrou = rsdgrou + p14(jthk)*sbgr
      enddo
c
      rddgrou = 0.d0
      do jthk = 1, nknots
         ths = thknot(jthk)
         rsdg  = 0.d0
         do jv = 1, nknots
           thv = thknot(jv)
            call smcrm
     &  (penalty, bc1, bs1, bdplants, bdsoil)
            sbgr = (1.d0 -skyl)*(bc1 + bs1) + bdplants + bdsoil
            rsdg = rsdg + p14(jv)*sbgr
         enddo
         rddgrou = rddgrou + p14(jthk)*rsdg
      enddo
c
      phi = phisave
      ths = thssave
      thv = thvsave
      return
      end
*
************************************************************************
*
