      subroutine  cubcirc(ntst, xtst, ytst, atst)
c
c   knots and weights of the cubature in a circle
c                                      A. Kuusk  27.08. 2002
c   Vysotskikh, I.P., Nauka, M., 1981, Ch. 5, P-t. 16.33.
c
c   No input,
c   Output:
c     ntst, xtst, ytst, atst
c
      include 'par.h'
      dimension xtst(ncub), ytst(ncub), atst(ncub)
      dimension ri(8)
      common /pidr/ pi, dr
      data ri/1.d0, 2.d0, 4.d0, 5.d0, 7.d0, 8.d0, 10.d0, 11.d0/
c
      ntst = ncirc
*     ntst = 48
      r1 = sqrt((10.d0 - sqrt(10.d0))/15.d0)
      r2 = sqrt((10.d0 + sqrt(10.d0))/15.d0)
      r3 = sqrt((31.d0 - sqrt(601.d0))/60.d0)
      r4 = sqrt(3.d0/5.d0)
      r5 = sqrt((31.d0 + sqrt(601.d0))/60.d0)
      c1 = (340.d0 + 25.d0*sqrt(10.d0))*pi/10368.d0
      c2 = (340.d0 - 25.d0*sqrt(10.d0))*pi/10368.d0
      c3 = (857.d0 + 12707.d0/sqrt(601.d0))*pi/20736.d0
      c4 = 125.d0*pi/3456.d0
      c5 = (857.d0 - 12707.d0/sqrt(601.d0))*pi/20736.d0
c
      do k = 1, 8
         xtst(k)   = r1*cos(pi*ri(k)/6.d0)
         ytst(k)   = r1*sin(pi*ri(k)/6.d0)
         atst(k)   = c1
         xtst(8+k) = r2*cos(pi*ri(k)/6.d0)
         ytst(8+k) = r2*sin(pi*ri(k)/6.d0)
         atst(8+k) = c2
      enddo
      do k = 1, 4
         xtst(16+k) = r3*cos(pi*dble(k)/2.d0)
         ytst(16+k) = r3*sin(pi*dble(k)/2.d0)
         atst(16+k) = c3
         xtst(20+k) = r4*cos(pi*dble(k)/2.d0)
         ytst(20+k) = r4*sin(pi*dble(k)/2.d0)
         atst(20+k) = c4
         xtst(24+k) = r5*cos(pi*dble(k)/2.d0)
         ytst(24+k) = r5*sin(pi*dble(k)/2.d0)
         atst(24+k) = c5
      enddo
c
      return
      end
*
************************************************************************
*
