      subroutine  cubell9(ntst, xtst, ytst, ztst, atst)
c
c   knots and weights of the cubature in a sphere
c                                      A. Kuusk  08.01.2003
c   Mysovskih,I.P. Interpolyatsionnye kubaturnye formuly, 
c   Nauka, Moskva 1981, Chpt. 5, Algorithm 16.31.
c
c   No input,
c   Output:
c     ntst, xtst, ytst, ztst, atst
c
      include 'par.h'
c
      parameter (nface = 20)
      dimension xtst(ncub), ytst(ncub), ztst(ncub), atst(ncub)
      dimension xi(ncub), yi(ncub), zi(ncub)
      dimension i1(nface), i2(nface), i3(nface)
      common /pidr/ pi, dr
      data 
     & i1/2,  2,  2,  2,  2,  3,  3,  3,  3,  3, 
     &    4,  4,  4,  5,  5,  6,  6,  7,  7,  8/, 
     & i2/4,  4,  5,  6,  7,  9,  9, 10, 11, 12, 
     &    5,  8,  9,  6,  9,  7, 10,  8, 11, 12/,
     & i3/5,  8,  6,  7,  8, 10, 13, 11, 12, 13,
     &    9, 13, 13, 10, 10, 11, 11, 12, 12, 13/
c
      ntst = 45
      vol  = pi*4.d0/3.d0
c
      atst(1) = vol*2096.d0/42525.d0
      do itst = 2, 13
         atst(itst) = vol*(491691.d0 + 54101.d0*sqrt(31.d0))/21.0924d6
      enddo
      do itst = 14, 25
         atst(itst) = vol*(491691.d0 - 54101.d0*sqrt(31.d0))/21.0924d6
      enddo
      do itst = 26, 45
         atst(itst) = vol*1331.d0/68.04d3
      enddo
c
      alph = sqrt(81.d0 - 6.d0*sqrt(31.d0))/11.d0
      beta = sqrt(81.d0 + 6.d0*sqrt(31.d0))/11.d0
      gamm = 3.d0/sqrt(11.d0)
c
c                                   *****    ceneter of sphere
      xtst(1) = 0.d0
      ytst(1) = 0.d0
      ztst(1) = 0.d0
c                                   *****    verteces of icosahedron (12)
      xi(2) = 0.d0
      xi(3) = 0.d0
      yi(2) = 0.d0
      yi(3) = 0.d0
      zi(2) = 1.d0
      zi(3) = -1.d0
      do i = 4, 8
         xi(i) = cos(dble(i - 4)*2.d0*pi/5.d0)*2.d0/sqrt(5.d0)
         xi(i+5) = cos(dble(2*(i - 4) + 1)*
     &             2.d0*pi/5.d0)*2.d0/sqrt(5.d0)
         yi(i) = sin(dble(i - 4)*2.d0*pi/5.d0)*2.d0/sqrt(5.d0)
         yi(i+5) = sin(dble(2*(i - 4) + 1)*
     &             2.d0*pi/5.d0)*2.d0/sqrt(5.d0)
         zi(i) = 1.d0/sqrt(5.d0)
         zi(i+5) = -1.d0/sqrt(5.d0)
      enddo
      do i = 2, 13
         xtst(i) = xi(i)*alph
         ytst(i) = yi(i)*alph
         ztst(i) = zi(i)*alph
         xtst(i+12) = xi(i)*beta
         ytst(i+12) = yi(i)*beta
         ztst(i+12) = zi(i)*beta
      enddo
c
c                                  ***** projections of facets' centers
c
      i  = 1
      xz = xi(i1(i)) + xi(i2(i)) + xi(i3(i))
      yz = yi(i1(i)) + yi(i2(i)) + yi(i3(i))
      zz = zi(i1(i)) + zi(i2(i)) + zi(i3(i))
      rz = sqrt(xz**2 + yz**2 + zz**2)
      xtst(26) = xz/rz*gamm
      ytst(26) = yz/rz*gamm
      ztst(26) = zz/rz*gamm
      do i = 2, nface
         xtst(i+25) = (xi(i1(i)) + xi(i2(i)) + xi(i3(i)))/rz*gamm
         ytst(i+25) = (yi(i1(i)) + yi(i2(i)) + yi(i3(i)))/rz*gamm
         ztst(i+25) = (zi(i1(i)) + zi(i2(i)) + zi(i3(i)))/rz*gamm
      enddo
c
*     do j = 1, ntst
*        write (*, '(i2, 4g12.5)')
*    &   j, xtst(j), ytst(j), ztst(j), atst(j)
*     enddo
c
      return
      end
*
************************************************************************
*
