      subroutine gfzx
     & (sntr, zcctr, cell, aell, dbhmn, ugx, 
     & glmp, zzx, sthx, cthx, sproj, tauz)
c
c Calculation of the gap fraction at level zzx in direction thv.
c A. Kuusk 5.04.2024
c   
c  Input:
c    & glmp, z1, sthv, cthv
c  Output:
c    aa1z
c
      include 'par.h'
c
      data eps/.1d-4/
c
      htr = zcctr + cell
      hbase = max((zcctr - cell), 0.d0)
      tgthx = sthx/cthx
      call pcrown
     &  (tgthx, zzx, zcctr, cell, aell, ugx, 
     &  vzx, sproj, rmnxy, azxu)
      b11v = bij(azxu, glmp)
c                                          stems
      if (tgthx .lt. eps .or. zzx .ge. hbase) then
        styv = 0.d0
      else
        call stem(zzx, hbase, dbhmn, htr, styx)
        styv  = styx*tgthx
      endif
      tauz = sntr*(b11v*sproj + styv)
c
      return
      end
*
************************************************************************
*
