      subroutine ggg1
     & (thx, thm, ee, ellmy, ellsig, ggx)
c  G-function for a Markov chain structure
c  J. Ross,  The Radiation Regime and Architecture of Plant Stands
c  Junk,  The Hague,  1981.
c  Kuusk, A. A Markov chain model of canopy reflectance,
c  Agricult. Forest Meteorol., 1995, 76(3-4): 221-236.
c  A. Kuusk    22.03.1988 & 16.06.1992 & 20.01.2000
c  0 <= thx <= pi/2
c
c
      include 'par.h'
      common /pidr/ pi, dr
c
      if (ee .lt. .4d0) then
         ggx  = .5d0
         goto 99
      endif
c
      sthx  = sin(thx)
      cthx  = cos(thx)
c
      cthm  = cos(thm)
      sthm  = sin(thm)
      ct1m  = cthx*cthm
      pi21  = pi/2.d0
      if ((thx+thm-pi21) .le. 0.d0) then
         sg1 = ct1m
      else
         sthz = ct1m/(sthx*sthm)
         sg1 = (ct1m*atan2(sthz,sqrt(1.d0 - sthz*sthz)) +
     &         sqrt((sthx*sthm)**2 - ct1m*ct1m))/pi21
      endif
c
      ggx = 
     & max((2.653d0*ellmy+1.432d0*ellsig)*(sg1-.5d0)+.50072d0, 0.d0)
c
99    continue
      return
      end
*
******************************************************************
*
