      subroutine hetk8s
     & (ncl, ths, thv, phi, nzs, sntr, zcctr, cmean, crrmn, dbhmn, 
     & ggsu, ggvu, aas, aav, pslv, pstr, psvgr, 
     & psgvus, pdgfu, pdgfd, ptrsu, ptrsd)
c
c            Gap probabilities               A. Kuusk   1.12.2000
c            Modified for elliptical LAD 3.12.2012
c  Input:
c    lelli, ncl, shl, nzs, nsun, phi,
c    stdns, htr, hc1, hc2, rcr, dbh, uuu, 
c    uuu() - leaf&branch area density in the tree crown jcl
c  Output:
c    aas, aav, p11gr, psgvus, pdgfu, pdgfd, ptr1uk, 
c    ptr1dk
c
      include 'par.h'
      include 'stands.h'
      include 'volint.h'
c
      save sths, cths, sthv, cthv, calph, zz1
c
      dimension pdgfu(nclmax), pdgfd(nclmax)
      dimension ptrsu(nclmax), ptrsd(nclmax)
c
c                 The gap probability in view direction aav on ground
      sthv = sin(thv)
      cthv = cos(thv)
      sths = sin(ths)
      cths = cos(ths)
      sthx = sthv
      cthx = cthv
      cell = cmean
      aell = crrmn
      zzx = 0.d0
      ugx = ggvu
      call gfzx
     & (sntr, zcctr, cell, aell, dbhmn, ugx, 
     & glmp, zzx, sthx, cthx, sproj, tauz)
      tauzv = tauz
      sprojv = sproj
      aav = exp(-tauzv) 
c              The gap probability in sun direction aas on ground
      sthx = sths
      cthx = cths
      ugx = ggsu
      call gfzx
     & (sntr, zcctr, cell, aell, dbhmn, ugx, 
     & glmp, zzx, sthx, cthx, sproj, tauz)
      tauzs = tauz
      sprojs = sproj
      aas = exp(-tauzs)
c
      sphi = sin(phi)
      cphi = cos(phi)
c                               the probability to see sunlit ground
      calph  = sthv*sths*cphi + cthv*cths
      alph = acos(calph)
c                     crown level hot-spot correction for the
c                     bidirectional free lines of sight
      if (sprojv .gt. sprojs) then
        tauc = tauzv*(calph/(1.d0 + alph))**4
      else
        tauc = tauzs*(calph/(1.d0 + alph))**4
      endif
      tausv = tauzs + tauzv - tauc
      psvgr = exp(-tausv)
c                       the probabilities to see sunlit foliage and stem
      psgvus = 0.d0
      sumplv = 0.d0
      sumptr = 0.d0
      do jcl = 1, ncl
        lellj = lelli(jcl)
        stdj  = stdns(jcl)
        htrj  = htr(jcl)
        hc1j  = hc1(jcl)
        hc2j  = hc2(jcl)
        rcrj  = rcr(jcl)
        dbhj  = dbh(jcl)
        uuuj  = uuu(jcl)
        shlj  = shl(jcl)
        gg3vj = gg3v(jcl)
        sths = sin(ths)
        cths = cos(ths)
        calph  = sthv*sths*cphi + cthv*cths
        gg3sj = gg3s(jcl)
c                                                     ellipsoid
        if (lellj) then 
          call int3de
     & (sntr, htrj, hc1j, rcrj, uuuj, shlj, gg3sj, gg3vj, 
     & zcctr, cmean, crrmn, dbhmn, ggsu, ggvu, glmp, 
     & sths, cths, sthv, cthv, sphi, cphi, calph, gfjju, gfjjd)
        else
          call int3dc
     & (nzs, sntr, htrj, hc1j, hc2j, rcrj, uuuj, shlj, gg3sj, gg3vj, 
     & zcctr, cmean, crrmn, dbhmn, ggsu, ggvu, glmp,
     & sths, cths, sthv, cthv, sphi, cphi, calph, gfjju, gfjjd)
        endif
        pdgfu(jcl) = gfjju
        pdgfd(jcl) = gfjjd
c
        call pstem
     & (lellj, nzs, sntr, htrj, hc1j, hc2j, rcrj, dbhj, zcctr, 
     & cmean, crrmn, dbhmn, ggsu, ggvu, glmp, ths, thv, 
     & sths, cths, sthv, cthv, sphi, cphi, calph, ptr1u, ptr1d)
        ptrsu(jcl) = ptr1u
        ptrsd(jcl) = ptr1d
c
        pplv = gfjju*uuuj*sqrt(gg3sj*gg3vj/cths/cthv)*stdj
        pptr = ptr1u*stdj
        psgvus = psgvus + pplv + pptr
        sumplv = sumplv + pplv
        sumptr = sumptr + pptr
*                  write (*, '(a/ 2f8.2, 6f10.6)') 
*    &    'hetk8s:thv,ths,aav,pgr,plv,ptr,sum_p', thv/dr, ths/dr, 
*    &    aav, psgrj, sumplv, sumptr, psgrj+sumplv+sumptr
      enddo
      pslv = sumplv
      pstr = sumptr
*      write (*, '(f6.1, 2f8.4)') thv/dr, pstr, pslv
*                  write (0, '(a/ 2f8.2, 6f10.6)') 
*    &    'hetk8s2:thv,ths,aav,pgr,plv,ptr,sum_p', thv/dr, ths1/dr, 
*    &    aav, psgr, pslv, pstr, psgr+pslv+pstr
c 
      return
      end
*
************************************************************************
*
