      subroutine int3dc
     & (nzs, sntr, htrj, hc1j, hc2j, rcrj, uuuj, shlj, gg3sj, gg3vj, 
     & zcctr, cmean, crrmn, dbhmn, ggsu, ggvu, glmp,
     & sths, cths, sthv, cthv, sphi, cphi, calph, gfjju, gfjjd)
c
c                             3D integral, cyl+cone    A. Kuusk 5.03.2024
c
      include 'par.h'
      include 'volint.h'
      common /pidr/ pi, dr
c
      save bgpu, bgpd
c
      aell    = rcrj
      a2      = aell**2
      vhcon  = hc1j
      vhcyl  = hc2j
      zxr    = htrj - hc1j
      htrmax = zcctr + cmean
      ntstz   = 2*nzs
c
      sumucon = 0.d0
      sumdcon = 0.d0
      sumucyl = 0.d0
      sumdcyl = 0.d0
      ulgs  = uuuj*gg3sj
      ulgv  = uuuj*gg3vj
c                                                  3D integral
c                                                        cylinder
      if (vhcyl .gt. 0d0) then
        do itst = 1, ntstz
          sxyu   = 0.d0
          sxyd   = 0.d0
          ztsti  = (zctst(itst) - 1.d0)/2.d0*vhcyl
          atsti  = acztst(itst)*vhcyl/2.d0
          rcirc  = aell
          do jtst = 1, nctst
            xtstj = xctst(jtst)*rcirc
            ytstj = yctst(jtst)*rcirc
            atstj = actst(jtst)*rcirc**2
            xi = xtstj
            yj = ytstj
            zk = ztsti
            call rcone
     &  (xi, yj, zk, sthv, cthv, sphi, cphi,
     &   aell, vhcon, vhcyl, rlout)
            rllvu  = rlout
            call rcone
     &  (xi, yj, zk, sthv, -cthv, sphi, -cphi,
     &   aell, vhcon, vhcyl, rlout)
            rllvd  = rlout
            call rcone
     &  (xi, yj, zk, sths, cths, 0.d0, 1.d0,
     &   aell, vhcon, vhcyl, rlout)
            rlls = rlout
c                             ! hot-spot correction inside the crown
            call hsc12
     & (calph, rllvu, rllvd, rlls, ulgs, ulgv, shlj, bgpu, bgpd)
            zz1  = zk + rlls*cths + zxr
            zz2  = zk + rllvu*cthv + zxr
            zz3  = zk - rllvd*cthv + zxr
c
            call bgf2
     &   (sntr, zcctr, cmean, crrmn, dbhmn, 
     &   ggsu, ggvu, glmp, zz1, zz2, zz3, sths, cths, 
     &   sthv, cthv, sphi, cphi, calph, aavj, aasj, poou, pood)
            sxuj  = bgpu*poou
            sxdj  = bgpd*pood
            sxyu = sxyu + sxuj*atstj
            sxyd = sxyd + sxdj*atstj
          enddo
          sumucyl = sumucyl + sxyu*atsti
          sumdcyl = sumdcyl + sxyd*atsti
        enddo
      else
        sxyu = 0.d0
        sxyd = 0.d0
      endif
c                                                       cone
      if (vhcon .gt. 0d0) then
        sumucon = 0.d0
        sumdcon = 0.d0
        do itst = 1, ntstz
          ztsti  = (zctst(itst) + 1.d0)/2.d0*vhcon
          atsti  = acztst(itst)*vhcon/2.d0
          rcirc  = aell*(1.d0 - ztsti/vhcon)
          sxyu   = 0.d0
          sxyd   = 0.d0
          do jtst = 1, nctst
            xtstj = xctst(jtst)*rcirc
            ytstj = yctst(jtst)*rcirc
            atstj = actst(jtst)*rcirc**2
            xi = xtstj
            yj = ytstj
            zk = ztsti
            call rcone
     &   (xi, yj, zk, sthv, cthv, sphi, cphi,
     &    aell, vhcon, vhcyl, rlout)
            rllvu  = rlout
            call rcone
     &   (xi, yj, zk, sthv, -cthv, sphi, -cphi,
     &    aell, vhcon, vhcyl, rlout)
            rllvd  = rlout
            call rcone
     &   (xi, yj, zk, sths, cths, 0.d0, 1.d0,
     &    aell, vhcon, vhcyl, rlout)
            rlls = rlout
c                             ! hot-spot correction inside the crown
            call hsc12
     & (calph, rllvu, rllvd, rlls, ulgs, ulgv, shlj, bgpu, bgpd)
c                bgp? - bidirectional gap probability inside the crown
c
            zz1  = zk + rlls*cths + zxr
            zz2  = zk + rllvu*cthv + zxr
            zz3  = zk - rllvd*cthv + zxr
c
            if (zz1 .ge. htrmax .or. zz2 .ge. htrmax) then
              poou = 1.d0
            else
              call bgf2
     &   (sntr, zcctr, cmean, crrmn, dbhmn, 
     &   ggsu, ggvu, glmp, zz1, zz2, zz3, sths, cths, sthv, cthv, 
     &   sphi, cphi, calph, aavj, aasj, poou, pood)
            endif
c
            sxuj  = bgpu*poou
            sxdj  = bgpd*pood
            sxyu = sxyu + sxuj*atstj
            sxyd = sxyd + sxdj*atstj
          enddo
          sumucon = sumucon + sxyu*atsti
          sumdcon = sumdcon + sxyd*atsti
        enddo
      endif
      sumu = sumucon + sumucyl
      sumd = sumdcon + sumdcyl
c
      gfjju = sumu
      gfjjd = sumd
      return
      end
*
************************************************************************
*
