      subroutine int3de
     & (sntr, htrj, hc1j, rcrj, uuuj, shlj, gg3sj, gg3vj, 
     & zcctr, cmean, crrmn, dbhmn, ggsu, ggvu, glmp, 
     & sths, cths, sthv, cthv, sphi, cphi, calph, gfjju, gfjjd)
c
c                             3D integral, ellipsoid    A. Kuusk 5.03.2024
c
      include 'par.h'
      include 'volint.h'
c
      save bgpu, bgpd
c
      aell    = rcrj
      a2      = aell**2
      cell   = hc1j*.5d0
      zxr    = htrj - cell
      htrmax = zcctr + cmean
c
      sumu    = 0.d0
      sumd    = 0.d0
      ulgs  = uuuj*gg3sj
      ulgv  = uuuj*gg3vj
c                                                  3D integral
      do itst = 1, netst
        xi = xetst(itst)*aell
        yj = yetst(itst)*aell
        zk = zetst(itst)*cell
        atsti = aetst(itst)
c
        call rlips
     &    (xi, yj, zk, sthv, cthv, sphi, cphi, aell, cell, rlout)
        rllvu  = rlout
        call rlips
     &  (xi, yj, zk, sthv, -cthv, sphi, -cphi, aell, cell, rlout)
        rllvd  = rlout
        call rlips
     &    (xi, yj, zk, sths, cths, 0.d0, 1.d0, aell, cell, rlout)
        rlls = rlout
c                                  ! hot-spot correction inside crown
        call hsc12
     & (calph, rllvu, rllvd, rlls, ulgs, ulgv, shlj, bgpu, bgpd)
c                bgp? - bidirectional gap probability inside the crown
c
        zz1  = zk + rlls*cths + zxr
        zz2  = zk + rllvu*cthv + zxr
        zz3  = zk - rllvd*cthv + zxr
c
        if (min(zz1, zz2) .ge. htrmax) then
          poou = 1.d0
        else
          call bgf2
     &   (sntr, zcctr, cmean, crrmn, dbhmn, 
     &   ggsu, ggvu, glmp, zz1, zz2, zz3, sths, cths, 
     &   sthv, cthv, sphi, cphi, calph, aavj, aasj, poou, pood)
        endif
c
        sxuj  = bgpu*poou
        sxdj  = bgpd*pood
        sumu = sumu + sxuj*atsti
        sumd = sumd + sxdj*atsti
      enddo
c
*     v_ell = 4.d0/3.d0*pi*a2*cell
      gfjju = sumu*a2*cell
      gfjjd = sumd*a2*cell
      return
      end
*
************************************************************************
*
