      subroutine iterats(clmpx, fgx)
C*************************************************************)
C*      Interpolation of the Gi values in the function       *)
C*      Ci-lnGi/(1-Gi)=0 using the Newton-Raphson method     *)
C*                                 (22.04.97)  Anne Jo~eveer *)
c       muutsin 14.06.2021  A. Kuusk
C*************************************************************)
c
      include 'par.h'
c
      save clmpj
c
      dimension fgi(nfgi),  clmpj(nfgi)
c
      data fgi/0.1d0, 0.2d0, 0.3d0, 0.4d0, 0.6d0, 0.8d0, 0.9d0, 0.95d0,
     & 0.98d0, 1.d0, 1.02d0, 1.05d0, 1.1d0, 1.2d0, 1.5d0, 2.d0, 3.0d0, 
     & 5.0d0/
      data eps/.1d-6/, eps2/.1d-4/
c
c
         do j = 1, nfgi
            if (abs(fgi(j)-1.d0) .gt. eps) then
              clmpj(j) = -log(fgi(j))/(1.d0 - fgi(j))
            else
              clmpj(j) = (3 - fgi(j))/2.d0
            endif
         enddo
c
      fgx    = 1.d0
      if (abs(1.d0 - clmpx) .lt. eps2) goto 18
c
      g1     = 0.001d0
      do i = 1, nfgi-1
         if (clmpx .le. clmpj(i) .and. clmpx .gt. clmpj(i+1)) then
            g1   = fgi(i)
            g2   = fgi(i+1)
            xacc = 0.1d-7
            call rtsafe(clmpx, g1, g2, xacc, fgx)
            goto 18
         endif
      enddo
      if (clmpx .lt. clmpj(nfgi)) fgx = 5.d0
c
18    continue
      end
*
************************************************************************
*
