      subroutine out0
     & (ijob, ncl, nbnds, nxx, llxx, iaer, dcaer, dvis, 
     & dtaer55, thsd, thvd, dthvd, phid, xc, xmin, xmax, xdelt, 
     & dwl, frefr, fprice, lig, mv, dname, oufile) 
c                         write input parameters   A. Kuusk 3.03.2024
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c
      logical lig, lml
      character*2 trl
      character*6 mv
      character*20 tex
      character*32 tjob
      character*40 dname
c
      dimension tex(nvar), tjob(8), dcaer(4)
      dimension llxx(nvar), xmin(nvar), xmax(nvar), xdelt(nvar) 
      dimension xc(nclmax, nvar)
c
      common /pidr/ pi, dr
      common /par/  zeps, tol, tiny, ftol, alphopt, betopt, gammopt, 
     & at, dxopt, ier, ncount, nfmax, itmax, itbr, nbrak, ilo
c
      data trl/'# '/
      data lml/.true./
      data tjob /' - single run', ' - spectrum', 
     & ' - angular distribution', ' - inversion, relative errors', 
     & ' - inversion, absolute errors', ' - inversion, BRF', ' ', ' '/
      data elli/'  ellips'/, koon/'  cone+c'/
      data (tex(j), j=1,19)/' stand density, m-2', ' tree height, m',
     & ' ell. or cone', ' cylinder, m', 
     & ' crown radius, m', ' trunk d, cm', 
     & ' total leaf weight', ' leaf weight, g m-2', 
     & ' eln', ' thm', ' shoot size, m', ' BAI/LAI', 
     & ' tree distr. param.', ' g_H-G', 
     & ' shoot shading coef', ' refr. ind. ratio',
     & ' leaf str.par', ' D_cell, mcm', ' i-cell air'/
      data (tex(j),j=20,29)/' c1, % of SLW', ' c2, % of SLW', 
     & ' c3, % of SLW', ' c4, % of SLW', ' c5, % of SLW', 
     & ' c6, % of SLW', ' c7, % of SLW', ' c8, % of SLW', 
     & ' c9, % of SLW', ' c10, % of SLW'/ 
      data (tex(j),j=30,48)/' ground LAI2', ' leaf size', 
     & ' clmp', ' szz', ' eln', ' thm',
     & ' n_ratio', ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW'/ 
      data (tex(j), j=49,70)/' ground LAI1', ' leaf size', 
     & ' clmp', ' eln', ' thm', ' n_ratio', 
     & ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW', ' s1_soil', ' s2', ' s3', ' s4'/
c
      iwr    = 1
      open (iwr, file = oufile, status = 'unknown')
c                                               ! Print input data
      rewind iwr
      write (iwr, '(a/3a)') trl, 
     & trl, '  Forest Reflectance Model V.11.2024', 
     & '  by A. Kuusk, T. Nilson'
      write (iwr, '(a/a/3a, i4)') trl,
     & '# Input parameters:', trl, dname, '  Stand Age  = ', age
c
      write (iwr, '(a, i3)') '##  ijob = ', ijob
c
      if (ijob .eq. 0) then
        write (iwr, '(3(a, f5.1), /a, f5.1, a)') '#   Sun zenith = ',
     &  thsd, '  View zenith = ', thvd, ' View azimuth = ', 
     &  phid, '#   Wavelength = ', wlarr(1), ' nm'
        if (iaer .eq. -1) then
          write (iwr, '(a)') '#  '
          write (iwr, '(a)') '#  No sky radiation   (BDRF)'
          write (iwr, '(a)') '#  '
        else
          write (iwr, '(a)') '# 6S parameters'
          write (iwr, '(a, i3, 4f8.3)') '#   iaer, c(n):', iaer,
     &          (dcaer(n), n=1,4)
          write (iwr, '(a, 2f8.3)') '#   v,km, tau550:', dvis, dtaer55
          write (iwr, '(a)') '#  '
        endif
      endif
c
      if (ijob .eq. 1) then
        write (iwr, '(3(a, f5.1), /a, i6, a)') '#   Sun zenith = ',
     &  thsd, '  View zenith = ', thvd, '  View azimuth = ', 
     &  phid
        if (iaer .eq. -1) then
          write (iwr, '(a)') '#  '
          write (iwr, '(a)') '#  No sky radiation   (BDRF)'
          write (iwr, '(a)') '#  '
        else
          write (iwr, '(a)') '# 6S parameters'
          write (iwr, '(a, i3, 4f8.3)') '#   iaer, c(n):', iaer,
     &          (dcaer(n), n=1,4)
          write (iwr, '(a, 2f8.3)') '#   v,km, tau550:', dvis, dtaer55
          write (iwr, '(a)') '#  '
        endif
        write (iwr, '(a, i6, a)') trl, nbnds, ' spectral bands'
      endif
c
      if (ijob .eq. 2)
     & write (iwr, '(3(a, f5.1), /a, f5.1, a)') '#   Sun zenith = ',
     & thsd, ' View azimuth = ', phid, '  View zenith step = ',
     & dthvd, '#   Wavelength = ', wlarr(1), ' nm'
c
      if (ijob .eq. 3)
     & write (iwr, '(a)') '#   Model inversion, relative differences'
c
      if (ijob .eq. 4)
     & write (iwr, '(a)') '#   Model inversion, absolute differences'
c
      if (ijob .eq. 5)
     & write (iwr, '(a)') '#   Model inversion, several view directions'
c
        write (iwr, '(a, i3, a)') trl,
     & ncl, ' tree class(es)'
      if (ncl .gt. 1) write (iwr, '(a46 / a, 12(2x, a16))')
     & '#   Files of parameters of other tree classes:',
     & trl, (clfile(jcl), jcl = 2, ncl)
c
      do jcl = 1, ncl
        if (lelli(jcl)) then
          kuju(jcl) = elli 
        else
          kuju(jcl) = koon 
        endif
      enddo  
c
      if (ijob .lt. 3) then
         write (iwr, '(a, 24x, 25(i4, 4x))') trl,  (i, i = 1, ncl)
         write (iwr, '(a, 27x, 22a8)') trl,
     &    (liik(jcl), jcl = 1, ncl)
         write (iwr, '(a, 25x, 20a8)')
     &    trl, (kuju(jcl), jcl = 1, ncl)
c
      jx = 1
         write (iwr, '(a, i3, 1x, a20, 28f8.4)') trl,
     & jx, tex(jx), (xc(jcl, jx),  jcl = 1, ncl)
      j2 = 19
      do jx = 2, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), (xc(jcl, jx),  jcl = 1, ncl)
      enddo
      write (iwr, '(a21, 12(2x, a24))') '#   bark refl. files: ',
     & (brreflf(jcl), jcl = 1, ncl)
      write (iwr, '(a21, 12(2x, a24))') '#   trunk refl. files:',
     & (trreflf(jcl), jcl = 1, ncl)
c
      write (iwr, '(a, 1x, a14, 2x, 10a18)')
     & trl, 'Leaf models: ', (lmod3(jcl), jcl = 1, ncl)
         write (iwr, '(a, 2x, a17, 2x, 12i8)')
     & trl, '# of leaf comp-s:', (ncomp3(jcl), jcl = 1, ncl)
      ncmax = 1
      do jc = 1, ncl
         if (ncomp3(jc) .gt. ncmax) ncmax = ncomp3(jc)
      enddo
      do jc = 1, ncmax
         jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)')
     & trl, (fcoef3(jcl, jc), jcl = 1, ncl)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), (xc(jcl, jx), jcl = 1, ncl)
      enddo
c
      write (iwr, '(a/a)') trl, '# *** Ground vegetation, upper layer'
      j1 = 30
      j2 = 38
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx)
      enddo
c
      write (iwr, '(a, 2x, a12, 2x, a12)')
     & trl, 'Leaf model: ', lmod2
      write (iwr, '(a, 2x, a21, i6)')
     & trl, '# of leaf components:', ncomp2
      do jc = 1, ncomp2
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)')
     & trl, fcoef2(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx)
      enddo
c
      write (iwr, '(a)') '# *** Ground vegetation, lower layer'
      j1 = 49
      j2 = 56
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx)
      enddo
c
      write (iwr, '(a, 2x, a12, 2x, a12)')
     & trl, 'Leaf model: ', lmod1
      write (iwr, '(a, 2x, a21, i6)')
     & trl, '# of leaf components:', ncomp1
      do jc = 1, ncomp1
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)') trl, fcoef1(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx)
      enddo
c
      write (iwr, '(3a)') trl, 'File of Price'' vectors: ', fprice
      write (iwr, '(2a, f5.1)') trl, 
     & 'Sun angle of the soil reflectance: ', thss/dr
      j1 = 67
      j2 = 70
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx)
      enddo
c
      else
c
         write (iwr, '(a, 20x)', advance='no') trl
         do icl = 1, ncl
           write (iwr, '(i8)', advance='no') icl
         enddo
         write (iwr, '(3x, 3(3x, a))') 'xmin ', 'xmax ', 'dx'
         write (iwr, '(a, 27x, 22a8)') trl,
     &    (liik(jcl), jcl = 1, ncl)
         write (iwr, '(a, 25x, 20a8)')
     &    trl, (kuju(jcl), jcl = 1, ncl)
c
      jx = 1
         write (iwr, '(a, i3, 1x, a20, 28f8.4)') trl,
     & jx, tex(jx), (xc(jcl, jx),  jcl = 1, ncl), 
     & xmin(jx), xmax(jx), xdelt(jx)
      j2 = 19
      do jx = 2, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), (xc(jcl, jx),  jcl = 1, ncl), 
     & xmin(jx), xmax(jx), xdelt(jx)
      enddo
      write (iwr, '(a21, 12(2x, a24))') '#   bark refl. files: ',
     & (brreflf(jcl), jcl = 1, ncl)
      write (iwr, '(a21, 12(2x, a24))') '#   trunk refl. files:',
     & (trreflf(jcl), jcl = 1, ncl)
c
      write (iwr, '(a, 1x, a14, 2x, 10a18)')
     & trl, 'Leaf models: ', (lmod3(jcl), jcl = 1, ncl)
         write (iwr, '(a, 2x, a18, 12i8)')
     & trl, '# of leaf comp-s:', (ncomp3(jcl), jcl = 1, ncl)
      ncmax = 1
      do jc = 1, ncl
         if (ncomp3(jc) .gt. ncmax) ncmax = ncomp3(jc)
      enddo
      do jc = 1, ncmax
         jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)')
     & trl, (fcoef3(jcl, jc), jcl = 1, ncl)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), (xc(jcl, jx), jcl = 1, ncl), 
     & xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a/a)') trl, 
     & '# *** Ground vegetation, upper layer  xmin    xmax    dx'
      j1 = 30
      j2 = 38
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a, 2x, a12, 2x, a12)')
     & trl, 'Leaf model: ', lmod2
      write (iwr, '(a, 2x, a21, i6)')
     & trl, '# of leaf components:', ncomp2
      do jc = 1, ncomp2
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)')
     & trl, fcoef2(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a)') '# *** Ground vegetation, lower layer'
      j1 = 49
      j2 = 56
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a, 2x, a12, 2x, a12)')
     & trl, 'Leaf model: ', lmod1
      write (iwr, '(a, 2x, a21, i6)')
     & trl, '# of leaf components:', ncomp1
      do jc = 1, ncomp1
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)') trl, fcoef1(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(3a)') trl, 'File of Price'' vectors: ', fprice
      write (iwr, '(2a, f5.1)') trl, 
     & 'Sun angle of the soil reflectance: ', thss/dr
      j1 = 67
      j2 = 70
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
         write (iwr, '(a/a, i6, 3(a, i4), 2(/(a, 4g10.2)))') trl,
     &    '# nfmax = ', nfmax, '      itmax = ', itmax,
     &    '     itbr  = ', itbr, '      nbrak = ', nbrak,
     &    '# zeps, tolbr, tiny, ftolp: ', zeps, tol, tiny, ftol,
     &    '# alpha, beta, gamma, dx: ', alphopt, betopt, gammopt, dxopt
         if (lig) then
            write (iwr, '(a, g8.3, a)') '# at  = ', at, 'lx = TRUE'
         else
            write (iwr, '(a, g8.3, a)') '# at  = ', at, 'lx = FALSE'
         endif
         write (iwr, '(a, i3, 3x, a, 15i4)')
     &         '# n   = ', nxx, '  ll = ', (llxx(i), i = 1, nxx)
      endif
c                  !  print input reflectances and transmittances
c
      if (ijob .eq. 3 .or. ijob .eq. 4) then
         write (iwr, '(a/a, f5.1, a, f6.1/a/a)') trl,
     &     '# thv = ', thvd, '   phi = ', phid,
     &     '# Input reflectance',
     &     '#       lambda    refl.    d_rho'
         do jw = 1, nbnds
           write (iwr, '(a, f10.1, 2f10.4)') trl, wlarr(jw),
     &     bqjarr(jw), drhoarr(jw)
         enddo
      endif
c
      if (ijob .eq. 5) then
         write (iwr, '(a/a, f5.1, 4x, a, f7.1/a/a)') trl,
     &     '# Sun zenith angle', thsd, 'Spectral band', wlarr(1),
     &     '# Input reflectance',
     &     '#    th_view  phi_view    refl.'
         do jr = 1, nbnds
            write (iwr, '(a, 2f10.1, f10.4)') trl,
     &          thvr(jr), phir(jr), bqjarr(jr)
         enddo
      endif
c
      write (iwr, '(a)') '#  '
      close(iwr)
c
      return
      end
*
************************************************************************
*

