      subroutine out1
     & (ijob, ncl, nbnds, nview, 
     & thsd, thvd, dthvd, phid, thtv00, xc, dname, oufile)
c                  Output results, direct run       A. Kuusk 3.03.2024
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c
      logical lig, lml
      character*2 trl
      character*20 tex
      character*32 tjob
      character*40 dname
c
      dimension tex(nvar), tjob(8)
      dimension xc(nclmax, nvar)
      common /pidr/ pi, dr
c
      data lml/.true./, lig/.false./
      data trl/'# '/
      data tjob /' - single run', ' - spectrum', 
     & ' - angular distribution', ' - inversion, relative errors', 
     & ' - inversion, absolute errors', ' - inversion, BRF', ' ', ' '/
      data (tex(j), j=1,19)/' stand density, m-2', ' tree height, m',
     & ' ell. or cone', ' cylinder, m', 
     & ' crown radius, m', ' trunk d, cm', 
     & ' lf_wght/tr&tot_m-2', ' SLW, g m-2', 
     & ' eln', ' thm', ' shoot size, m', ' BAI/LAI', 
     & ' tree distr. param.', ' g_H-G', 
     & ' shoot shading coef', ' refr. ind. ratio',
     & ' leaf str.par', ' D_cell, mcm', ' i-cell air'/
      data (tex(j),j=20,29)/' c1, % of SLW', ' c2, % of SLW', 
     & ' c3, % of SLW', ' c4, % of SLW', ' c5, % of SLW', 
     & ' c6, % of SLW', ' c7, % of SLW', ' c8, % of SLW', 
     & ' c9, % of SLW', ' c10, % of SLW'/ 
      data (tex(j),j=30,48)/' ground LAI2', ' leaf size', 
     & ' clmp', ' szz', ' eln', ' thm',
     & ' n_ratio', ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW'/ 
      data (tex(j), j=49,70)/' ground LAI1', ' leaf size', 
     & ' clmp', ' eln', ' thm', ' n_ratio', 
     & ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW', ' s1_soil', ' s2', ' s3', ' s4'/
c
      iwr    = 1
c                                         Output results, direct run
c                                         Input parameters and mean values
      if (ijob .eq. 1 .and. jpass .eq. 2) goto 551
c
      open (iwr, file = oufile, status = 'old')
        do j = 1, 6000
           read (iwr, '(1x)', end = 64)
        enddo
64      continue
        backspace iwr
      write (iwr, '(a/a)') trl, '# *** Results:'
c
      write (iwr, '(a, 24x, 27(i4, 6x))') trl, (jcl, jcl = 1, ncl)
      write (iwr, '(a, 25x, 27a10)') trl, (liik(jcl), jcl = 1, ncl),
     &         'totals    '
      write (iwr, '(a, 23x, 25a10)') trl, (kuju(jcl), jcl = 1, ncl)
c
      ncmax = 1
      do jc = 1, ncl
         if (ncomp3(jc) .gt. ncmax) ncmax = ncomp3(jc)
      enddo
c
      j1 = 1
      j2 = 19
      do jx = j1, j2
            write (iwr, '(a, 1x, a20, 28f10.3)')
     & trl, tex(jx), (xc(jcl, jx),  jcl = 1, ncl), x_m(jx)
      enddo
c
      write (iwr, '(a21, 17(2x, a24))') '#   bark refl. files: ',
     & (brreflf(jcl), jcl = 1, ncl)
      write (iwr, '(a21, 17(2x, a24))') '#   trunk refl. files:',
     & (trreflf(jcl), jcl = 1, ncl)
      write (iwr, '(a, 1x, a13, 2x, 15a12)')
     & trl, 'Leaf models: ', (lmod3(jcl), jcl = 1, ncl)
      write (iwr, '(a, 1x, a17, 15i10)')
     & trl, '# of leaf comp-s:', (ncomp3(jcl), jcl = 1, ncl)
      do jc = 1, ncmax
         jx = j2 + jc
            write (iwr, '(a, 5x, 15a18)')
     & trl, (fcoef3(jcl, jc), jcl = 1, ncl)
            write (iwr, '(a, 1x, a20, 28f10.2)')
     & trl, tex(jx), (xc(jcl, jx), jcl = 1, ncl)
      enddo
c
         j1 = 30
         j2 = 38
c
      write (iwr, '(4(a, f7.4))') '#   rl_eff = ', r_leff,
     & '  tl_eff = ', t_leff, '  n_eff = ', r_neff, '  rsl = ', rsl
      write (iwr, '(a, 1x, a19, 1x, 26f10.3)') trl,
     & 'leaf area density ', (u_uu(jcl), jcl = 1, ncl)
      write (iwr, '(a, 2x, a9, 2x, f8.3)')
     & trl, 'Total LAI', t_lai
      write (iwr, '(a, 2x, a9, 2x, f8.3)')
     & trl, 'Total BAI', x_m(12)
      write (iwr, '(a, f6.3, 8x, a, f6.3)')
     & '#   crown closure = ', crcl, 'canopy closure = ', cacl
      if ( jwcl .gt. 0) then
        write (*, '(/a)')
     &    '*** Warning!: canopy closure (CC) > crown closure (CR)'
        write (*, '(a, i4, 2g12.4/)')
     &    '          class, CR, CC:', jwcl, wvliit, wcano
        write (iwr, '(a/a)') trl,
     &    '# Warning!: canopy closure (CC) > crown closure (CR)'
        write (iwr, '(a, i4, 2g12.4/a)')
     &    '#           class, CR, CC:', jwcl, wvliit, wcano, trl
      endif
c
      if (ijob .eq. 0) then
        write (iwr, '(a)') '#        z          uz'
        do jz = 1, 400
          if (u_uz(jz) .gt. 0.d0) then
            write (iwr, '(a, 2f12.4)') trl, jz*0.1d0, u_uz(jz)
            jzmax = jz
          endif
        enddo
        jz = jzmax + 1
        write (iwr, '(a, 2f12.4)') trl, jz*0.1d0, u_uz(jz)
      endif
c
      write (iwr, '(a/a)') trl, '#  *** Ground vegetation, upper layer'
      j1 = 30
      j2 = 38
      do jx = j1, j2
         write (iwr, '(a, 1x, a20, 28f10.2)')
     & trl, tex(jx), xc(1, jx)
      enddo 
c
      write (iwr, '(a, 2x, a12, 2x, 15a8)')
     & trl, 'Leaf model: ', lmod2
      write (iwr, '(a, 2x, a21, i8)')
     & trl, '# of leaf components:', ncomp2
      do jc = 1, ncomp2
         jx = j2 + jc
         write (iwr, '(a, 5x, 15a18)') trl, fcoef2(jc)
         write (iwr, '(a, 1x, a20, 28f10.2)')
     & trl, tex(jx), xc(1, jx)
      enddo
c     
c
      write (iwr, '(a)') '#  *** Ground vegetation, lower layer'
         j1 = 49
         j2 = 56
      do jx = j1, j2
            write (iwr, '(a, 1x, a20, 28f10.2)')
     & trl, tex(jx), xc(1, jx)
      enddo
c
      write (iwr, '(a, 2x, a12, 2x, 15a8)')
     & trl, 'Leaf model: ', lmod1
      write (iwr, '(a, 2x, a21, i8)')
     & trl, '# of leaf components:', ncomp1
      do jc = 1, ncomp1
         jx = j2 + jc
         write (iwr, '(a, 5x, 15a18)') trl, fcoef1(jc)
         write (iwr, '(a, 1x, a20, 28f10.2)')
     & trl, tex(jx), xc(1, jx)
      enddo
c
         j1 = 67
         j2 = 70
      do jx = j1, j2
         write (iwr, '(a, 1x, a20, 28f10.4)')
     & trl, tex(jx), xc(1, jx)
      enddo
c
c                               Output results
c                          *************  ijob = 0 - the single run
551   continue
      if (ijob .eq. 0) then
        jview = 1
        jbnd = 1
        rlambda = wlarr(jbnd)
        jwl = nint((rlambda - (400.d0 - wlstep))/wlstep)
        write (*, '(3(a, f5.1), a, f7.1)')
     &     ' th_s = ', thsd, '    th_view = ', thvd,
     &     '    phi = ', phid/dr, '    Spectral band ', rlambda
        write (*, '(a, 15f14.1)') ' th_s: ', thsd
        write (*, '(a, 15f14.5/)')' bq_j: ', rth(jbnd)
        write (*, '(a, 15f14.5/)')' r_gr: ', rsth(jbnd)
        write (*, '(a, 15f14.2)') ' S''/Q: ', sqa(jwl)
c
         write (iwr, '(a/a/3a, i4)') trl,
     &    '# Input parameters:', trl, dname, '  Stand Age  = ', age
         write (iwr, '(a, i3)') '##  ijob = ', ijob
         write (iwr, '(3(a, f5.1), a, f7.1)')
     &      ' th_sun = ', thsd, '    th_view = ', thvd,
     &      '    phi = ', phid, '    Spectral band ', rlambda
         write (iwr, '(a, 15f14.2)') ' S''/Q: ', sqa(jwl)
         write (iwr, '(a, f8.4, 8x, a, f8.4)') ' CaCl: ', cacl,
     &       'CrCl: ', crcl
         if (cacl .gt. crcl) write (iwr, '(a)')
     &      '*** Warning!: canopy closure CaCl > crown closure CrCl'
c
         write (iwr, '(/2a)') '# thv', '     refl  '
         write (iwr, '(f6.2, f12.5)') thvd, rth(jbnd)
         write (iwr, '(a)') 'Components:'
         write (iwr, '(a, f12.5)') 'r_ground', rsth(jbnd)
         write (iwr, '(a, f12.5)') 'r_cr1   ', rcr1(jbnd)
         write (iwr, '(a, f12.5)') 'r_gr1   ', rgr1(jbnd)
         write (iwr, '(a, f12.5)') 'r_dif   ', rdif(jbnd)
         write (iwr, '(a, f12.5)') 'b_down  ', bdown(jbnd)
c
         write (iwr, '(/a)') 'Probabilities:'
         write (iwr, '(a, f10.5)')
     &         'Gap fraction in Sun direction ', aas
         write (iwr, '(a, f10.5)') 
     &         'Gap fraction in view direction', aav
         write (iwr, '(a, 17x, f10.5)') 
     &         'Sunlit ground', p11gr(jview)
         write (iwr, '(a, f10.5)') 
     &         'Sunlit foliage in tree crowns ', p11lvs(jview)
         write (iwr, '(a, 17x, f10.5)') 
     &         'Sunlit stems ', p11tr(jview)
         write (iwr, '(a, 17x, f10.5)') 
     &         'Total sunlit ', 
     &   p11gr(jview)+p11lvs(jview)+p11tr(jview)
c
         goto 777
      endif
c
      if (ijob .eq. 1) then
      open (iwr, file = oufile, status = 'old')
        do j = 1, 6000
           read (iwr, '(1x)', end = 66)
        enddo
66      continue
        backspace iwr
           write (iwr, '(a/, 3(a, f5.1), /a, i6, a)') trl,
     &      '#   Sun zenith = ', thsd, '  View zenith = ',
     &      thvd, '  View azimuth = ', phid,
     &      trl, nbnds, ' spectral bands'
           write (iwr, '(a, 4(6x, a), 3(9x, a))') '# wl, nm', 'refl.',
     &      'b_down', ' r_ground','S''/Q','rcr1', 'rgr1', 'rdif'
           write (iwr, '(a)') trl
c
        do jbnd = 1, nbnds
          rlambda = wlarr(jbnd)
          jwl = nint((rlambda - (400.d0 - wlstep))/wlstep)
          write (iwr, '(f8.1, 2x, 7g13.5)')
     &    wlarr(jbnd), rth(jbnd), bdown(jbnd),
     &    rsth(jbnd), sqa(jwl), rcr1(jbnd), rgr1(jbnd), rdif(jbnd)
        enddo
c                              ********** End of the spectrum loop
        goto 777
      endif
c
      if (ijob .eq. 2) then
        jbnd = 1
        open (iwr, file = oufile, status = 'old')
        do j = 1, 6000
           read (iwr, '(1x)', end = 67)
        enddo
67      continue
        backspace iwr
        rlambda = wlarr(jbnd)
        jwl = nint((rlambda - (400.d0 - wlstep))/wlstep)
        write (iwr, '(a)') trl
        write (iwr, '(3(a, f5.1))') '#   Sun zenith = ', thsd,
     & '   View azimuth = ', phid, '   View zenith step = ', dthvd
        write (iwr, '(a, f5.1, 2a, f5.1)') '#   Wavelength = ', 
     & rlambda, ' nm     ', "   S'/Q = ", sqa(jwl)
        write (iwr, '(a, f8.4, 15x, a, f8.4)') '#   CaCl: ', cacl,
     &       'CrCl: ', crcl
        if (cacl .gt. crcl) write (iwr, '(a/a)') trl, 
     &      '# *** Warning!: canopy closure CaCl > crown closure CrCl'
        write (iwr, '(a)') trl
*       write (iwr, '(2a)') '# thv', '     refl  '
        write (iwr, '(4a, 4(7x, a), 4(4x, a))') '# thv', '     refl  ',
     & '     r_grnd', '     rcr1', 'rgr1', 'rdif', 'b_down',
     & 'gfr  ', 'p11_gr ', 'p11_lvs', 'p11_tr', 'p11_total'
*       write (iwr, '(4a, 4(7x, a), 4(4x, a))') '# thv', '     refl  ',
*    & '     r_grnd', '   b_down', 'gfr ', 'rcr1', 'rgr1',
*    & 'rdif ', 'p11_gr ', 'p11_lvs', 'p11_tr', 'p11_total'
c
         nthv  = nview
         thtv0  = -(thtv00/dthvd + 1)*dthvd
c
         do jv = 1, nthv
            thv = (thtv0 + jv*dthvd)
            if (abs(thv) .lt. dr) thv   = 0.d0
*           write (iwr, '(f6.1, f11.5)') thv, rth(jv)
            write (iwr, '(f6.1, 11f11.5)') thv, rth(jv), rsth(jv),
     &          rcr1(jv), rgr1(jv), rdif(jv), bdown(jv), aavth(jv), 
     &          p11gr(jv), p11lvs(jv), p11tr(jv), 
     &          p11gr(jv)+p11lvs(jv)+p11tr(jv)
*           write (iwr, '(f6.1, 11f11.5)') thv, rth(jv), rsth(jv),
*    &          bdown(jv), aavth(jv), rcr1(jv), rgr1(jv), rdif(jv), 
*    &          p11gr(jv), p11lvs(jv), p11tr(jv), 
*    &          p11gr(jv)+p11lvs(jv)+p11tr(jv)
*      write (*, '(f6.1, 2f8.4)') thv, rcr1(jv), p11lvs(jv)
         enddo
c                              ********** End of the AD loop
      endif
c
777   continue
      close (iwr)
      return
      end
*
************************************************************************
*

