      subroutine out2
     & (ijob, ncl, nbnds, nxx, llxx, ipass, iter, xc, xmin, xmax, 
     & xdelt, xx, fff, dname, oufile)
c                  Output results, inversion       A. Kuusk 3.03.2024
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c
      logical lml
      character*2 trl
      character*20 tex
      character*32 tjob
      character*40 dname
c
      dimension xmin(nvar), xmax(nvar), xx(nvar), xdelt(nvar)
      dimension llxx(nvar), xc(nclmax, nvar)
      dimension tex(nvar), tjob(8)
c
      common /pidr/ pi, dr
      common /par/  zeps, tol, tiny, ftol, alphopt, betopt, gammopt, 
     & at, dxopt, ier, ncount, nfmax, itmax, itbr, nbrak, ilo
c
      data lml/.true./
      data trl/'# '/
      data tjob /' - single run', ' - spectrum', 
     & ' - angular distribution', ' - inversion, relative errors', 
     & ' - inversion, absolute errors', ' - inversion, BRF', ' ', ' '/
      data (tex(j), j=1,19)/' stand density, m-2', ' tree height, m',
     & ' ell. or cone', ' cylinder, m', 
     & ' crown radius, m', ' trunk d, cm', 
     & ' total leaf weight', ' leaf weight, g m-2', 
     & ' eln', ' thm', ' shoot size, m', ' BAI/LAI', 
     & ' tree distr. param.', ' g_H-G', 
     & ' shoot shading coef', ' refr. ind. ratio',
     & ' leaf str.par', ' D_cell, mcm', ' i-cell air'/
      data (tex(j),j=20,29)/' c1, % of SLW', ' c2, % of SLW', 
     & ' c3, % of SLW', ' c4, % of SLW', ' c5, % of SLW', 
     & ' c6, % of SLW', ' c7, % of SLW', ' c8, % of SLW', 
     & ' c9, % of SLW', ' c10, % of SLW'/ 
      data (tex(j),j=30,48)/' ground LAI2', ' leaf size', 
     & ' clmp', ' szz', ' eln', ' thm',
     & ' n_ratio', ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW'/ 
      data (tex(j), j=49,70)/' ground LAI1', ' leaf size', 
     & ' clmp', ' eln', ' thm', ' n_ratio', 
     & ' SLW', ' leaf str.par',
     & ' c1, % of SLW', ' c2, % of SLW', ' c3, % of SLW',
     & ' c4, % of SLW', ' c5, % of SLW', ' c6, % of SLW', 
     & ' c7, % of SLW', ' c8, % of SLW', ' c9, % of SLW',
     & ' c10, % of SLW', ' s1_soil', ' s2', ' s3', ' s4'/
c
      iwr    = 1
c                               Output results, inversion

         open (iwr, file = oufile, status = 'old')
         do j = 1, 6000
            read (iwr, '(1x)', end = 65)
         enddo
65       continue
         backspace iwr
c
      write (iwr, '(a/a/a/a, i3/a)') trl, trl,
     &    '########################', '#  Results,     pass', ipass,
     &    '########################'
*     write (iwr, '(a/a, g20.14)') trl, '#  f(x0) = ', fff
      write (*, '(/a, e20.14, a, i4, a, i5, a, i3)')
     &    '  f = ', fff, '   iter = ', iter-1,
     &    '   ncount = ', ncount, '  ier = ', ier
         write (iwr, '(/a/a, e20.14, a, i4, a, i5, a, i3, a, f7.5)')
     &    trl, '# f = ', fff, '   iter = ', iter,
     &    '   ncount = ', ncount, '  ier = ', ier
c
         write (iwr, '(a/2a, 5x, i3, a, i3, 5x, a)') trl, trl, dname,
     &    nbnds, ' band(s)'
         write (iwr, '(a, 14f7.1)') 
     &    '# Sun angle:  ', ths/dr
c
         write (iwr, '(a, 47x, 25(i4, 4x))') trl,  (i, i = 1, ncl)
         write (iwr, '(a, 26x, 27a8)') trl,  'xmin  ', '  xmax  ',
     &     '   dx   ', (liik(i), i = 1, ncl), 'totals  '
c
      write (iwr, '(a, 48x, 25a8)') trl, (kuju(i), i = 1, ncl)
      jx = 1
      if (ncl .ge. 2) then
         write (iwr, '(a, i3, 1x, a20, 28f8.4)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx),
     & (xc(jcl, jx), jcl = 2, ncl), x_m(jx)
      else
         write (iwr, '(a, i3, 1x, a20, 28f8.4)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx), x_m(jx)
      endif
      j2 = 19
      do jx = 2, j2
         if (ncl .ge. 2) then
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx),
     & (xc(jcl, jx), jcl = 2, ncl), x_m(jx)
         else
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx), x_m(jx)
         endif
      enddo
c
      write (iwr, '(a, a23, 17(2x, a24))') trl,
     & '     bark refl. files: ', (brreflf(jcl), jcl = 1, ncl)
      write (iwr, '(a, a23, 17(2x, a24))') trl,
     & '     trunk refl. files:', (trreflf(jcl), jcl = 1, ncl)
c
      write (iwr, '(a, a26, 19x, 15i8)') trl,
     & '# of leaf components:', (ncomp3(jcl), jcl = 1, ncl)
      ncmax = 1
      do jc = 1, ncl
         if (ncomp3(jc) .gt. ncmax) ncmax = ncomp3(jc)
      enddo
      do jc = 1, ncmax
         jx = j2 + jc
         if (ncl .ge. 2) then
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx),
     & (xc(jcl, jx), jcl = 2, ncl), x_m(jx)
         else
            write (iwr, '(a, i3, 1x, a20, 28f8.3)') trl,
     & jx, tex(jx), xmin(jx), xmax(jx), xdelt(jx), xx(jx), x_m(jx)
         endif
      enddo
c
      write (iwr, '(3(a, f6.3))') '#    rl_eff = ', r_leff,
     & '  tl_eff = ', t_leff, '  n_eff = ', r_neff
      write (iwr, '(a, 4x, a19, 25x, 26f8.3)') trl,
     & 'leaf area density ', (u_uu(jcl), jcl = 1, ncl)
      write (iwr, '(a, 4x, a9, 2x, f8.3)') trl,
     & 'Total LAI', t_lai
      write (iwr, '(a, 4x, a9, 2x, f8.3)') trl,
     & 'Total BAI', x_m(12)
      write (iwr, '(a/a, f6.3, 9x, a, f6.3)') trl,
     & '#  crown closure = ', crcl, 'canopy closure = ', cacl
c
      write (iwr, '(a/a)') trl, '#*** Ground vegetation, upper layer'
      j1 = 30
      j2 = 38
      do jx = j1, j2
         write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     &   jx, tex(jx), xx(jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a, a17, 2x, 15a8)') trl, 'Leaf model: ', lmod2
      write (iwr, '(a, a26, i4)') trl,
     & '# of leaf components:', ncomp2
      do jc = 1, ncomp2
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)')
     & trl, fcoef2(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xc(1, jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a)') '#*** Ground vegetation, lower layer'
      j1 = 49
      j2 = 56
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xx(jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      write (iwr, '(a, a17, 2x, 15a8)') trl, 'Leaf model: ', lmod1
      write (iwr, '(a, a26, i4)') trl,
     & '# of leaf components:', ncomp1
      do jc = 1, ncomp1
           jx = j2 + jc
            write (iwr, '(a, 5x, 10a18)') trl, fcoef1(jc)
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xx(jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      j1 = 67
      j2 = 70
      do jx = j1, j2
            write (iwr, '(a, i3, 1x, a20, 28f8.2)') trl,
     & jx, tex(jx), xx(jx), xmin(jx), xmax(jx), xdelt(jx)
      enddo
c
      if (ier .eq. 1) then
      write (iwr, '(a/a, g11.4, a, i6, 4x, a, 20i3)') trl,
     &  '# f(x) =', fff, '  n =', nxx, 'll = ', (llxx(i), i = 1, nxx)
c
        if (ijob .eq. 3 .or. ijob .eq. 4) then
           write (iwr, '(a/a, f5.1, a, f6.1/a)') trl,
     &       '# thv = ', thv/dr, '   phi = ', phi/dr,
     &       '# lambda measured_refl, d_rho, fitted_refl.'
          write (iwr, '(f10.0, 3f10.4)') (wlarr(jw),
     &            bqjarr(jw), drhoarr(jw),
     &            r_out(jw), jw = 1, nbnds)
        endif
c
*       if (ijob .eq. 5) then
*          dmean = 0.d0
*          write (iwr, '(a/a, f5.1, 4x, a, f7.1/a)') trl,
*    &    '# Sun zenith angle', thsd, 'Spectral band', wlarr(1),
*    &  '#   thv   phiv      refl_in   refl_ou   delta     ratio'
*          do jr = 1, nrefl
*             write (iwr, '(2f8.1, 4f10.4)')
*    &        thvr(jr), phir(jr), bqjarr(jr), r_out(1, jr),
*    &        r_out(1, jr) - bqjarr(jr), r_out(1, jr)/bqjarr(jr)
*             dmean = dmean + abs(r_out(1, jr) - bqjarr(jr))
*          enddo
*          dmean = dmean/nrefl
*          write (iwr, '(a, f10.4)') '# delta_mean: ', dmean
*       endif
      endif
c
      close (iwr)
      return
      end
*
************************************************************************
*

