      subroutine pcrown
     &  (tgthx, zzx, zcctr, cell, aell, ugx, 
     &   vzx, sproj, rmnz, azxu)
c
c  crown transparency a1, ellipsoid, at level zzx. A. Kuusk 6.02.2024
c  aell, cell - semiaxes, zcctr - z of ellipsoid center
c
      include 'par.h'
      include 'volint.h'
      common /pidr/ pi, dr
      data eps/0.001d0/, epsd/0.001d0/
c
      ntst = ncirc
      cth = 1.d0/sqrt(1.d0 + tgthx**2)
      sth = sqrt(1.d0 - cth**2)
      sphi = 0.d0
      cphi = -1.d0
      ugxx = ugx/(2*cell)
      aell2 = aell**2
      cell2 = cell**2
      ac2   = aell2/cell2
*     vell = 4.d0/3.d0*pi*cell*aell2
      zze  = max(zzx - zcctr, -cell)
      rrz2 = (cell2 - zze**2)*ac2
      rrz  = sqrt(rrz2)
      vzx  = pi*ac2*(cell - zze)/3.d0*
     &       (2.d0*cell2 - zze*(cell + zze))
        if (zze .gt. 0.d0) then
          aproj = rrz
        else
          aproj = aell
        endif
      if (abs(tgthx) .lt. eps) then
c                                vertical projection
        xxt = aell
        zzt = 0.d0
        cproj = aproj
        sproj = pi*aproj*cproj
      else
c                                           upper tangent point
        rmm = -1.d0/tgthx
        amm = abs(rmm)
        amm2 = amm**2
        zep  = zze/amm
        ww2 = aell2*amm2 + cell2
        ww = sqrt(ww2)
        xxt = amm/ww*aell2
        zzt1 = -amm*xxt + ww
        zzt2 = -amm*xxt - ww
        zzt  = max(zzt1, zzt2)
c                                           semiaxes of the projection
        cproj = ww/amm
        cproj2 = cproj**2
        sprojell = pi*aell*cproj
*         print *, 'xxt, zzt: ', xxt, zzt
c           ss1 - segment of the circle, ss2 - of the ellipse
        if (zze .gt. zzt) then
          ss1 = pi*rrz2
          ss2 = 0.d0
        else if (zze .le. -zzt) then
          ss1 = 0.d0
          ss2 = sprojell
        else if (zze .le. -zzt) then
          ss1 = 0.d0
          ss2 = sprojell
        else
          aaa = cproj2 - aell2
          bbb = -zep*cproj2
          ccc = cproj2*(aell2 + zep**2 - rrz2)
          dd2 = bbb**2 - aaa*ccc
          if (abs(dd2) .lt. epsd) then
            ddd = 0.d0
          else
            ddd = sqrt(dd2)
          endif
          y12 = (-bbb + ddd)/aaa
          y12p = y12
          ss2 = aell*(cproj*(pi/2.d0 - asin(y12/cproj)) - 
     &        y12/cproj*sqrt(cproj2 - y12**2))
          yyz = abs(y12 - zep)
          pha = atan(aell*sqrt(cproj2 - y12**2)/cproj/yyz)
          alph = 2.d0*pha
          s1x = rrz2*(alph - sin(alph))/2.d0
          if (zep .lt. 0.d0) then
            ss1 = s1x
          else
            ss1 = pi*rrz2 - s1x
          endif
          sproj = ss1 + ss2
*            print *, 'S2:', zze, ss1, ss2
        endif
        sproj = ss1 + ss2
      endif
c                                      2D integral over projection area
c                       ! Kui projektsioon on ring, arvutan 2D kvadratuuriga
c               ! Vertikaalne vaade või zzx>zzt
      if (abs(tgthx) .lt. eps .or. zze .ge. zzt) then
        sum1 = 0.d0
        sumt = 0.d0
        do jq = 1, ntst
          xtj = xctst(jq)
          ytj = yctst(jq)
          atjc = actst(jq)
          xxx = xtj*aproj
          yyy = ytj*aproj
          rxy2 = xxx**2 + yyy**2
          if (abs(tgthx) .lt. eps) then
            hxy = cell*sqrt(1.d0 - rxy2/aell2)
            if (zze .ge. 0.d0) then
              dxy = hxy - zze
            else if (zze .lt. 0.d0 .and. zze .gt. -hxy) then
              dxy = 2.d0*hxy + zze
            else
              dxy = 2.d0*hxy
            endif
            txy   = exp(-ugxx*dxy)
*           txy   = exp(-ugx/cth)
*         write (*, '(a, 5f10.4)') 'pcrown,zze.xxx,yyy,rxy,dxy:', 
*    &          zze, xxx, yyy, sqrt(rxy2), dxy
            sum1 = sum1 + atjc*dxy
            sumt = sumt + atjc*txy
          else if (zze .ge. zzt) then
c                                    zzx kõrgemal kui puutuja, zzx > zzt
            yye = yyy
              call rlips
     &      (yye, xxx, zze, sth, cth, sphi, cphi, aell, cell, dxy)
            txy = exp(-ugxx*dxy)
*           txy = exp(-ugx/cth)
            sum1 = sum1 + atjc*dxy
            sumt = sumt + atjc*txy
          endif
        enddo
        rmnz = sum1/pi
        azxu = sumt/pi
        goto 40
      endif
c                              zzx madalamal kui puutuja, zzx < -zzt
c                              projektsioon on ellips (aproj,cproj)
c                                   2x1D integral over projection area
*      print *, '#sum31:', sum1, suma, sumt, sum3
      sum1 = 0.d0
      sumt = 0.d0
      do jq1 = 1, nknots
        ytmp = yctst(jq1)
        ytj = sign((1.d0 - abs(ytmp)), ytmp)
        atj1 = aptst(jq1)
        if (zze .le. -zzt) then
          yyy = ytj*cproj
          ryy = aproj/cproj*sqrt(cproj2 - yyy**2)
          clngth = cproj
        else
          ymin = zep - rrz
          ymax = cproj
          ycntr = (ymin + ymax)/2.d0
          clngth = (ymax - ymin)/2.d0
          yyy   = ytj*clngth + ycntr
          if (yyy .lt. y12p) then
            yyp = yyy - zep
            ryy = sqrt(rrz2 - yyp**2)
          else
            ryy = aproj/cproj*sqrt(cproj2 - yyy**2)
          endif
        endif
        yyp = yyy - zep
        sum2 = 0.d0
        sumt2 = 0.d0
        if (zze .le. -cell) ryy = aproj/cproj*sqrt(cproj2 - yyy**2)
        ryj = ryy/2.d0
        do jq2 = 1, nknots
          xtj = xptst(jq2)
          atj2 = aptst(jq2)
          xxx = xtj*ryj + ryj
          qq2 = yyp**2 + xxx**2
          if (qq2 .le. rrz2) then
c                          kiir siseneb ellipsoidi läbi lõikepinna
            call rlips
     &      (yyp, xxx, zze, sth, cth, sphi, cphi, aell, cell, dxy)
          else 
c                           kiir siseneb ellipsoidi läbi külgpinna
            bxy2 = aell2 - xxx**2
            zz0  = yyy*amm
            aaa  = aell2*amm2 + cell2
            dd2  = (aell2*amm*zz0)**2 -
     &            aaa*((aell*zz0)**2 - (cell2*bxy2))
            dxy = 2.d0*sqrt((amm2 + 1.d0)*dd2)/aaa
          endif
*      write (0, '(3f16.6)') xxx, yyy, dxy
          txy = exp(-ugxx*dxy)
          sum2 = sum2 + atj2*dxy
          sumt2 = sumt2 + atj2*txy
        enddo
        sum1 = sum1 + atj1*sum2
        sumt = sumt + atj1*sumt2
      enddo
*      print *, '#sum3:', sum3, suma, suma2
c
*39    continue
*     rvz = vzx/sproj/cth
*     azxu =   exp(-ugx*rvz)
      rmnz = sum1/4.d0
      tmn  = sumt/4.d0
      azxu = tmn
*      print *, '#nmean:', rvz, rmnz
c
40    continue
      return
      end
*
************************************************************************
*
