      subroutine pelld
     & (tgthx, zz12, htrj, cellj, rcrj, szdx, vzdi)
c                                                 A. Kuusk  16.11.2000
c   The projection szdx and volume vzdi of the lower part 
c   of an ellipsoid at the level zz12 in direction thx
c  Input:
c    tgthx, zz12, htrj, cellj, rcrj
c  Output:
c    szdx, vzdi
c   tgthx = tan(thx), htrj - tree height,
c   cellj - the semiaxis of the ellips, rcrj - crown radius
c
      include 'par.h'
      common /pidr/ pi, dr
c      
      data eps/.1d-4/
c
      hcrown = 2.d0*cellj
      hbase  = htrj - hcrown
c                                                              stem
      if (zz12 .ge. 0.d0 .and. zz12 .le. hbase) then
         szdx = 0.d0
         vzdi = 0.d0
         return
      endif
c                                                   above the crown
      if (zz12 .ge. htrj) then
         vzdi = 4.d0*pi*rcrj**2*cellj/3.d0
         szdx = sqrt(rcrj**2 + (cellj*tgthx)**2)*pi*rcrj
         return
      endif
c
      hcent = htrj - cellj
      zx    = zz12 - hcent
      vzdi  = pi*rcrj**2*(hcrown/3.d0 + zx - zx**3/3.d0/cellj**2)
      if (vzdi .lt. 0.d0) vzdi = 0.d0
c                                           the height of intersection
      if (tgthx .lt. eps) then
         z0 = 0.d0
      else
         z0 = cellj/sqrt(rcrj/(cellj*tgthx)**2 + 1.d0) 
      endif
c
      rz = sqrt(cellj**2 - zx**2)*rcrj/cellj
      if (abs(zx) .ge. z0) then
         if (zz12 .gt. hcent) then
c                                                   top of crown
            szdx = sqrt(rcrj**2 + (cellj*tgthx)**2)*pi*rcrj
         else
            szdx = pi*rz**2
         endif
      else
c                                           between intersection points
         xyz  = sqrt(rcrj**2 + (cellj*tgthx)**2)
         beta = acos(zx*tgthx/xyz)
         sel1 = rcrj*xyz*beta - rz*zx*tgthx
         sel3 = rcrj*xyz*(pi - beta) + rz*zx*tgthx
         szdx = sel1 + sel3
      endif
      return
      end
*
************************************************************************
*
