      subroutine pstem
     & (lellj, nzs, sntr, htrj, hc1j, hc2j, rcrj, dbhj, zcctr, 
     & cmean, crrmn, dbhmn, ggsu, ggvu, glmp, ths, thv, 
     & sths, cths, sthv, cthv, sphi, cphi, calph, ptr1u, ptr1d)
c                    Probability of sunlit stem    A. Kuusk 5.03.2024
c
      include 'par.h'
      include 'volint.h'
      common /pidr/ pi, dr
      data eps/.001d0/
c
      ntstz   = 2*nzs
      cell    = hc1j/2.d0
      hcrj   = hc1j + hc2j
      a2 = rcrj**2
      htrmax = zcctr + cmean
c
      ptr1u = 0.d0
      ptr1d = 0.d0
      utyu  = 0.d0
      utyd  = 0.d0
c                       zvari - the height of the crown shade
      tgths = sths/cths
      tgthx = max(tgths, eps)
      if (lellj) then
         zv = sqrt(a2 + (cell*tgths)**2)/tgthx          
      else
         zv = rcrj/tgthx
      endif
      zvari = htrj - hcrj - zv
c
      if (zvari .gt. 0.d0) then
        if (thv .lt. ths) then
          tgthv = sthv/cthv
          tgthx = max(tgthv, eps)
          if (lellj) then
             xxx = sqrt(a2 + (cell*tgthv)**2)
             zv = xxx/tgthx
          else
             zv = rcrj/tgthx
          endif
          zview = max(zvari, 0.d0)
        else
          zview = zvari
        endif
c
c                       ! uty - the area of sunlit stem
        utyd = dbhj*pi/2.d0*zvari
        utyu = dbhj*pi/2.d0*zview
c                              ! the integral of pooi over [0, zvari]
        dzenel = hcrj/ntstz
        if (zvari .le. dzenel) then
          dztrunk = zvari
        else
          dztrunk = dzenel
        endif
        nz = int(zvari/dztrunk + .5d0)
        nview = int(zview/dztrunk + .5d0) + 1
        dztrunk = zvari/nz
c
        if (nview .lt. nz) then
          do k = 1, nz + 1
            zk   = (k - 1)*dztrunk
            z2   = zk
            z3   = zk
c
            if (zk .ge. htrmax .and. z2 .ge. htrmax) then
              poouj = 1.d0
            else
              call bgf2
     & (sntr, zcctr, cmean, crrmn, dbhmn, 
     & ggsu, ggvu, glmp, zk, z2, z3, sths, cths, 
     & sthv, cthv, sphi, cphi, calph, aavj, aasj, poouj, poodj)
            endif
c
            if (k .eq. 1 .or. k .eq. nz) poodj = poodj/2.d0
            ptr1d = ptr1d + poodj
            if (k .eq. 1 .or. k .eq. nview) poouj = poouj/2.d0
            if (k .le. nview) ptr1u = ptr1u + poouj
          enddo
          ptr1d = ptr1d/nz
          ptr1u = ptr1u/nview
        else
          do k = 1, nz + 1
            zk   = (k - 1)*dztrunk
            z2   = zk
            z3   = zk
c
            if (zk .ge. htrmax .and. z2 .ge. htrmax) then
              poouj = 1.d0
            else
              call bgf2
     & (sntr, zcctr, cmean, crrmn, dbhmn, 
     & ggsu, ggvu, glmp, zk, z2, z3, sths, cths, 
     & sthv, cthv, sphi, cphi, calph, aavj, aasj, poouj, poodj)
            endif
c
            if (k .eq. 1 .or. k .eq. nz) then
               poodj = poodj/2.d0
               poouj = poouj/2.d0
            endif
            ptr1d = ptr1d + poodj
            ptr1u = ptr1u + poouj
          enddo
          ptr1d = ptr1d/nz
          ptr1u = ptr1u/nz
        endif
      endif
      ptr1u = ptr1u*utyu
      ptr1d = ptr1d*utyd
c
      return
      end
*
************************************************************************
*
