      subroutine rlips
     & (xi, yj, zk, sthrl, cthrl, sphrl, cphrl, aell, cell, rlout)
c
c   Distance from (xi, yj, zk) to crown perimeter in direction thet, phi
c   ellipsoid,  A. Kuusk, 29.12.1985
c  Input:
c    xi, yj, zk, sthrl, cthrl, sphrl, cphrl,
c    &  aell, cell
c  Output:
c    rlout
c   aell - crown radius, cell - crown length
c   phi - azimuth counted from x-axis
c   sthrl = sin(thet), cthrl = cos(thet), 0 <= thet <= pi/2
c   sphrl = sin(phi),  cphrl = cos(phi),  0 <= phi  <= pi
c   x,y,z = 0 in the center of ellipsoid
c
      include 'par.h'
c
      data eps/.1d-6/
c
      a2    = aell*aell
      c2    = cell*cell
      aaa   = c2*(sthrl**2) + a2*(cthrl**2)
      bbb   = 2.d0*(c2*sthrl*(xi*cphrl + yj*sphrl) + a2*cthrl*zk)
      ccc   = c2*(xi**2 + yj**2) + a2*(zk**2 - c2)
      det   = (bbb**2 - 4.d0*aaa*ccc)
      if (abs(det) .lt. eps) then
         rlout = -bbb*.5d0/aaa
      else
         rlout = (sqrt(det) - bbb)*.5d0/aaa
      endif
c
      if (rlout .lt. 0d0) rlout = 0.d0
c
      return
      end
*
************************************************************************
*
