      subroutine stands
     & (ijob, ncl, nbnds, nxx, llxx, iaer, dcaer, dvis, 
     & dtaer55, thsd, thvd, dthvd, phid, xc, xmin, xmax, xdelt, 
     & dwl, frefr, fprice, lig, mv, dname, oufile) 
c                         read input parameters   A. Kuusk 2.03.2024
      include 'par.h'
      include 'stands.h'
      include 'spectra.h'
      include 'func.h'
c
      logical lig
      character*6 mv
      character*32 tjob
      character*40 dname
      character fname*72
c
      dimension tjob(8), dcaer(4)
      dimension llxx(nvar), xmin(nvar), xmax(nvar), xdelt(nvar) 
      dimension xc(nclmax, nvar)
c
      common /pidr/ pi, dr
      common /par/  zeps, tol, tiny, ftol, alphopt, betopt, gammopt, 
     & at, dxopt, ier, ncount, nfmax, itmax, itbr, nbrak, ilo
c
      data tjob /' - single run', ' - spectrum', 
     & ' - angular distribution', ' - inversion, relative errors', 
     & ' - inversion, absolute errors', ' - inversion, BRF', ' ', ' '/
      data eps/.5d0/
c
      ire    = 2
      ncount = 0
      ier    = 0
      do jcl = 1, nclmax
        do jc = 1, ncomp0
          fcoef3(jcl, jc) = '_'
          xc(jcl, jc)     = 0.d0
          xdelt(jc)       = 0.d0
        enddo
        ncomp3(jcl) = 0
      enddo
c                         Read header and IJOB
      fname = clfile(1)
      open (ire, file = fname, status = 'old', err = 99)
        rewind ire
             jl = 1
        read (ire, *, err = 98) dname
        write (0, '(2a)') '# ', dname
             jl = jl + 1
        read (ire, *, err = 98) age
             jl = jl + 1
        read (ire, *, err = 98) ncl
        write (0, '(a, i3, a)') '#', ncl, ' tree class(es)'
             jl = jl + 1
        read (ire, *, err = 98)
             jl = jl + 1
        if (ncl .gt. 1) then
          read (ire, *, err = 98) frefr, (clfile(j), j = 2, ncl)
        else
          read (ire, *, err = 98) frefr
        endif
        read (ire, *, err = 98)
        read (ire, *, err = 98) ijob
c
        write (0, '(a, i3, 3a)')
     &   '# ijob = ', ijob, tjob(ijob+1), '    Output file: ', oufile
c                                                  ! Read 6S parameters
        read (ire, *, err = 98) iaer, (dcaer(j), j=1,4)
        read (ire, *, err = 98) dvis, dtaer55
c                       ! Read Sun angle, view angle and wavelengths 
        read (ire, *, err = 98) thsd
        read (ire, *, err = 98) thvd, dthvd, phid
        if (phid .gt. 180.d0) phid = 360.d0 - phid
        read (ire, *, err = 98) nbnds, dwl
        n_bnds = nbnds
        if (ijob .eq. 0 .or. ijob .eq. 2) nbnds = 1
        if (dwl .le. 0.d0) then
           read (ire, *, err = 98) (wlarr(jw), jw = 1, nbnds)
        else
           read (ire, *, err = 98) wlarr(1)
        endif
      close (ire)
c
      do jcl = 1, ncl
        fname = clfile(jcl)
        open (ire, file = fname, status = 'old', err = 99)
          rewind ire
          read (ire, '(12/)', err = 98)
c                           ! Read forest parameters
        jl = 14
          read (ire, *, err = 98)
          jl = jl + 1
          read (ire, *, err = 98) liik(jcl)           ! species
          jl = jl + 1
          read (ire, *, err = 98) lelli(jcl)          ! crown form
        j2 = 19
          if (ijob .lt. 3) then
            do jx = 1, j2                               ! jx = 1 .. 19
           jl = jl + 1
              read (ire, *, err = 98) xc(jcl, jx)
            enddo
           jl = jl + 1
            read (ire, *, err = 98) brreflf(jcl)      ! branch refl file
           jl = jl + 1
            read (ire, *, err = 98) trreflf(jcl)      ! stem refl file
           jl = jl + 1
            read (ire, *, err = 98) lmod3(jcl)         ! leaf optics model
           jl = jl + 1
            read (ire, *, err = 98) ncomp3(jcl)        ! # of leaf components
            do jc = 1, ncomp3(jcl)                     ! jx = 15 .. +ncomp3
           jl = jl + 1
              jx = j2 + jc
              read (ire, *, err = 98) xc(jcl, jx),
     &            dum1, dum2, dum3, fcoef3(jcl, jc)
            enddo
c                                                      ! ground vegetation
            if (jcl .eq. 1) then
              read (ire, *, err = 98)
              j1 = 30
              j2 = 38
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx)
              enddo
           jl = jl + 1
              read (ire, *, err = 98) lmod2          ! leaf optics model
           jl = jl + 1
              read (ire, *, err = 98) ncomp2
              do jc = 1, ncomp2                      ! jx = 39 .. +ncomp2
                jx = j2 + jc
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx),
     &            dum1, dum2, dum3, fcoef2(jc)
              enddo
c                                                    ! lower layer
              j1 = 49
              j2 = 56
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx)
              enddo
           jl = jl + 1
              read (ire, *, err = 98) lmod1          ! leaf optics model
           jl = jl + 1
              read (ire, *, err = 98) ncomp1
              do jc = 1, ncomp1                        ! jx = 57 .. +ncomp1
           jl = jl + 1
                jx = j2 + jc
                read (ire, *, err = 98) xc(jcl, jx),
     &            dum1, dum2, dum3, fcoef1(jc)
              enddo
c                                                     ! soil
            jl = jl + 1
              read (ire, *, err = 98) fprice, thssd
              thss  = thssd*dr
              j1 = 67                                ! soil
              j2 = 70
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx)
              enddo
            endif
c
c    ************                                       ! ijob > 2
c
          else
            do jx = 1, j2                               ! jx = 1 .. 19
           jl = jl + 1
              if (jcl .eq. 1) then
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx)
              else
                read (ire, *, err = 98) xc(jcl, jx)
              endif
            enddo
           jl = jl + 1
            read (ire, *, err = 98) brreflf(jcl)      ! branch refl file
           jl = jl + 1
            read (ire, *, err = 98) trreflf(jcl)      ! stem refl file
           jl = jl + 1
            read (ire, *, err = 98) lmod3(jcl)         ! leaf optics model
           jl = jl + 1
            read (ire, *, err = 98) ncomp3(jcl)        ! # of leaf components
            do jc = 1, ncomp3(jcl)                     ! jx = 15 .. +ncomp3
           jl = jl + 1
              jx = j2 + jc
              if (jcl .eq. 1) then
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx), fcoef3(jcl, jc)
              else
                read (ire, *, err = 98) xc(jcl, jx),
     &            dum1, dum2, dum3, fcoef3(jcl, jc)
              endif
            enddo
c                                                      ! ground vegetation
            if (jcl .eq. 1) then
              read (ire, *, err = 98)
              j1 = 30
              j2 = 38
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx)
              enddo
           jl = jl + 1
              read (ire, *, err = 98) lmod2          ! leaf optics model
           jl = jl + 1
              read (ire, *, err = 98) ncomp2
              do jc = 1, ncomp2                      ! jx = 39 .. +ncomp2
                jx = j2 + jc
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx), fcoef2(jc)
              enddo
c                                                    ! lower layer
              j1 = 49
              j2 = 56
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx)
              enddo
           jl = jl + 1
              read (ire, *, err = 98) lmod1          ! leaf optics model
           jl = jl + 1
              read (ire, *, err = 98) ncomp1
              do jc = 1, ncomp1                        ! jx = 56 .. +ncomp1
           jl = jl + 1
                jx = j2 + jc
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx), fcoef1(jc)
              enddo
            jl = jl + 1
              read (ire, *, err = 98) fprice, thssd
              thss  = thssd*dr
              j1 = 67                                ! soil
              j2 = 70
              do jx = j1, j2
           jl = jl + 1
                read (ire, *, err = 98) xc(jcl, jx),
     &            xmin(jx), xmax(jx), xdelt(jx)
              enddo
c                                        ! Read minimization parameters
           jl = jl + 1
              read (ire, *, err = 98) 
           jl = jl + 1
              read (ire, *, err = 98) mv
           jl = jl + 1
              read (ire, *, err = 98) nfmax, itmax, itbr, nbrak
           jl = jl + 1
              read (ire, *, err = 98) zeps, tol, tiny, ftol
           jl = jl + 1
              read (ire, *, err = 98) alphopt, betopt, gammopt, dxopt
           jl = jl + 1
              read (ire, *, err = 98) nxx, at, lig
c                         ! lig = .true.  - use the previous results
c                                           as initial guess
           jl = jl + 1
              read (ire, *, err = 98) (llxx(jx), jx = 1, nxx)
c
c
c                             ! Read reflectance/transmittance data
              if (ijob .eq. 3 .or. ijob .eq. 4) then
                do jw = 1, nbnds
           jl = jl + 1
                  read (ire, *, err = 98)
     &            dum1, bqjarr(jw), drhoarr(jw)
                  if (abs(dum1 - wlarr(jw)) .gt. eps) then
                    write (0, *)
     &        '*** Warning: Incorrect wavelength: wl = ', dum1,
     &                 '  jw = ', jw, wlarr(jw)
                  endif
                enddo
              else if (ijob .eq. 5) then
                do jr = 1, nbnds
                  read (ire, *, err = 98)
     &            thvr(jr), phir(jr), bqjarr(jr)
                enddo
              endif
            endif
          endif
        close (ire)
      enddo
c                                    Read tabulated spectra
      call rspec
     & (ncl, frefr, fprice, ncomp1, ncomp2)
c
      return
c
98    write (*, '(3a, i4)')
     &      'Error in the file ', fname, 'line ', jl
      return
99    write (*, '(a)')  'File not found: ', fname
      return
      end
*
************************************************************************
*
