      subroutine stem(z1, z2, dbhj, htrj, styvi)
c
c  The area of stem longitudinal section,  A. Kuusk   20.04.2005
c
c  Input:
c    z1, z2, dbhj, htrj
c  Output:
c    styvi
c  dbhj - brest-heigth diameter, htrj - tree heigth
c  Area is calculated integrating stem diameter from level z1 
c  to level z2. Stem tapering equation from Latvian 1988 directives.
c
      include 'par.h'
      dimension ati(7)
c  need parameetrid on männi jaoks
      data ati/118.981d0, -277.578d0, 1140.525d0, 
     & -3037.487d0, 4419.682d0, -3361.78d0, 997.657d0/
      data  ht0/26.d0/, dt0/30.d0/, pty/0.007d0/, qty/-0.007d0/
c
      xz0 = 1.3d0/htrj
      xz1 = z1/htrj
      xz2 = z2/htrj
      eet = pty*(htrj - ht0) + qty*(dbhj - dt0)
c
      sum1 = 0.d0
      do j = 1, 7
         sum1 = sum1 + ati(j)*(xz0**(j - 1))
      enddo
      f13 = sum1*(1.d0 + eet*(xz0*xz0 - 0.01d0))
c
      sum1 = 0.d0
      sum2 = 0.d0
      sum3 = 0.d0
      sum4 = 0.d0
      do j = 1, 7
         sum1 = sum1 + ati(j)/dble(j)*(xz1**j)
         sum2 = sum2 + ati(j)/dble(j)*(xz2**j)
         sum3 = sum3 + ati(j)/dble(j+3)*(xz1**(j + 3))
         sum4 = sum4 + ati(j)/dble(j+3)*(xz2**(j + 3))
      enddo
c
      styvi = (sum2 - sum1)*(1.d0 - 0.01d0*eet)
      styvi = styvi + eet*(sum4 - sum3)
      styvi = styvi*htrj*dbhj/f13
c
      return
      end
*
************************************************************************
*
